'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _badge = require('../badge/');

var _badge2 = _interopRequireDefault(_badge);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Tab = function (_React$Component) {
    (0, _inherits3["default"])(Tab, _React$Component);

    function Tab() {
        (0, _classCallCheck3["default"])(this, Tab);
        return (0, _possibleConstructorReturn3["default"])(this, _React$Component.apply(this, arguments));
    }

    Tab.prototype.render = function render() {
        var _props = this.props;
        var title = _props.title;
        var icon = _props.icon;
        var selectedIcon = _props.selectedIcon;
        var prefixCls = _props.prefixCls;
        var badge = _props.badge;
        var selected = _props.selected;
        var unselectedTintColor = _props.unselectedTintColor;
        var tintColor = _props.tintColor;

        return React.createElement(
            'div',
            null,
            React.createElement(
                'div',
                { className: prefixCls + '-icon' },
                badge ? React.createElement(
                    _badge2["default"],
                    { text: badge, className: prefixCls + '-badge' },
                    React.createElement('img', { className: prefixCls + '-image', src: selected ? selectedIcon.uri : icon.uri, alt: title })
                ) : React.createElement('img', { className: prefixCls + '-image', src: selected ? selectedIcon.uri : icon.uri, alt: title })
            ),
            React.createElement(
                'p',
                { className: prefixCls + '-title', style: {
                        color: selected ? tintColor : unselectedTintColor
                    } },
                title
            )
        );
    };

    return Tab;
}(React.Component);

exports["default"] = Tab;
module.exports = exports['default'];